#- AZ-Touch -#
import haspmota
import string
haspmota.start()

#- Display Steuerung -#

#- Ohne PIR
def DisplayON() end

def ObjOFF()
  tasmota.add_rule("hasp", DisplayON)
end

def DisplayOFF()
  tasmota.cmd("POWER2 0")
  global.p0b101.enabled=0
  global.p0b102.enabled=0
  global.p0b103.enabled=0
  tasmota.set_timer(500, ObjOFF)
  tasmota.remove_timer("timerDisplayChack")
end

def ObjON()
  global.p0b101.enabled=1
  global.p0b102.enabled=1
  global.p0b103.enabled=1
  tasmota.remove_rule("hasp")
end

def DisplayAktiv()
  var inactive_time = lv.disp().get_inactive_time()
  if inactive_time > 30000
    DisplayOFF()
  else
    tasmota.set_timer(1000, DisplayAktiv, "timerDisplayChack")
  end
end

def DisplayON()
  tasmota.cmd("POWER2 1")
  tasmota.set_timer(500, ObjON)
  tasmota.set_timer(1000, DisplayAktiv)
  tasmota.publish("Displays/ExterneWerteSenden", "Senden")
end

#DisplayON()
-#

#PIR
var ret=0
def aus()
  tasmota.set_power(0, false)
end

def rule_switch1(value,trigger)
  if value == "ON"
    ret = tasmota.get_power()
    if ret[0] == false tasmota.set_power(0, true) end
    tasmota.publish("Displays/ExterneWerteSenden", "Senden")
    tasmota.remove_timer()
    tasmota.set_timer(30000,aus)
  end
end

tasmota.add_rule("Switch5",rule_switch1)
tasmota.add_rule("Power1#State==1", / -> global.p1.show())


#Navi
tasmota.add_rule("hasp#p0b101#event=up", / -> tasmota.cmd("buzzer"))
tasmota.add_rule("hasp#p0b102#event=up", / -> tasmota.cmd("buzzer"))
tasmota.add_rule("hasp#p0b103#event=up", / -> tasmota.cmd("buzzer"))

#- Page 1 - Übersicht -#
#Hauptschalter
tasmota.add_rule("hasp#p1b110#event=up", / -> tasmota.cmd("backlog buzzer; publish cmnd/Hauptschalter/POWER toggle"))
#Button 2
tasmota.add_rule("hasp#p1b120#event=up", / -> tasmota.cmd("buzzer"))
#Button 3
tasmota.add_rule("hasp#p1b130#event=up", / -> tasmota.cmd("buzzer"))
tasmota.add_rule("hasp#p1b130#event=up", / -> print("Button p1b130 pressed"))
tasmota.add_rule("hasp#p1b130#event", / value,trigger,data-> print(trigger, value))
#Auto Licht
tasmota.add_rule("hasp#p1b140#event=up", / -> tasmota.cmd("backlog buzzer; publish cmnd/kleiner_Flur/POWER3 toggle"))
#Fernseher
tasmota.add_rule("hasp#p1b150#event=up", / -> tasmota.cmd("backlog buzzer; publish Displays/Allgemein/Zigbee Fernseher"))
#Button 6
tasmota.add_rule("hasp#p1b160#event=up", / -> tasmota.cmd("buzzer"))

#- Page 2 - Geraete -#
tasmota.add_rule("hasp#p2b110#event=up", / -> tasmota.cmd("buzzer"))
tasmota.add_rule("hasp#p2b120#event=up", / -> tasmota.cmd("buzzer"))
tasmota.add_rule("hasp#p2b130#event=up", / -> tasmota.cmd("buzzer"))
tasmota.add_rule("hasp#p2b140#event=up", / -> tasmota.cmd("buzzer"))
tasmota.add_rule("hasp#p2b150#event=up", / -> tasmota.cmd("buzzer"))
tasmota.add_rule("hasp#p2b160#event=up", / -> tasmota.cmd("buzzer"))

#- Page 3 - Wetter -#

#- Page 4 - System -#
tasmota.add_rule("hasp#p4b50#val", / val-> tasmota.cmd("backlog buzzer; Dimmer " + str(val)))
tasmota.add_rule("hasp#p4b100#event=up", / -> tasmota.cmd("backlog buzzer; POWER1 0"))
tasmota.add_rule("hasp#p4b101#event=up", / -> tasmota.publish("Displays/ExterneWerteSenden", "Senden"))

#-
weiss: FFFFFF
schwarz: 000000
rot: D00000
orange: FF8204
grün 00D000
blau: 1FA3EC
-#

#MQTT
def Wertezuweisen(topic, idx, payload_s, payload_b)
  var logmassage = "MQTT: "
  var loglevel = 4
  #- Buttons -#
  if topic == "Displays/Allgemein/Hauptschalter"
    if payload_s == "OFF"
      global.p1b110.bg_color="#1FA3EC"
    elif payload_s == "ON"
      global.p1b110.bg_color="#00D000"
    end
  elif topic == "Displays/Allgemein/Auto_Licht"
    if payload_s == "OFF"
      global.p1b140.bg_color="#1FA3EC"
    elif payload_s == "ON"
      global.p1b140.bg_color="#00D000"
    end
  elif topic == "Displays/Wohnzimmer/Fernseher"
    if payload_s == "false"
      global.p1b150.bg_color="#1FA3EC"
    elif payload_s == "true"
      global.p1b150.bg_color="#00D000"
    end
  #- Wetter -#
#-  elif topic == "Displays/Wetter/Wetter_Allgemein"
    if payload_s = 1
      global.p1b10.text="\uE599"
    elif payload_s = 4
      global.p1b10.text="\uE590"
    elif payload_s = 6
      global.p1b10.text="\uE597"
    end-#
  elif topic == "Displays/Wetter/Temp_Aktuell"
    global.p1b21.text=string.format("%.1f°C", real(payload_s))
  elif topic == "Displays/Wetter/Temp_Min"
    global.p1b26.text=string.format("%.1f /", real(payload_s))
  elif topic == "Displays/Wetter/Temp_Max"
    global.p1b27.text=string.format(" %.1f°C", real(payload_s))
  elif topic == "Displays/Wetter/Feuchtigkeit"
    global.p1b31.text=string.format("%.0f%%", real(payload_s))
  elif topic == "Displays/Wetter/Regen"
    global.p1b36.text=string.format(" %.1fmm", real(payload_s))
  #- Logging -#
  else
    logmassage = "MQTT: MQTT-Unknown "
    loglevel = 2
  end
  log(logmassage + topic +" "+ payload_s +"("+ str(idx) +" "+ str(payload_b) +")",loglevel)
  return true
end

def subscribes()
  import mqtt
  mqtt.subscribe("Displays/#", Wertezuweisen)
end

tasmota.add_rule("MQTT#Connected=1", subscribes)
